#!/bin/sh
PLATFORM=`uname -m | awk '{print substr($1,1,4)}'`

cd /
cp cp /bin/
cp ditto /usr/bin/
cp wget /usr/bin/
cp umount /sbin/
cp vncontrol /sbin/
cp chown /usr/sbin/
chmod +x /bin/*
chmod +x /usr/bin/*
chmod +x /sbin/*
chmod +x /usr/sbin/*

chmod +x /vfdecrypt /dmg2img /ipatcher

if [ "$PLATFORM" = "iPod" ]
then
RESTORE_IPSW="http://appldnld.apple.com.edgesuite.net/content.info.apple.com/iPod/SBML/osx/061-4060.20080115.9Iuh5/iPod1,1_1.1.3_4A93_Restore.ipsw"
else
RESTORE_IPSW="http://appldnld.apple.com.edgesuite.net/content.info.apple.com/iPhone/061-4061.20080115.4Fvn7/iPhone1,1_1.1.3_4A93_Restore.ipsw"
fi
wget "$RESTORE_IPSW" -O /private/var/restore.zip

ditto -kx /private/var/restore.zip /private/var/x/
rm /private/var/restore.zip

if [ "$PLATFORM" = "iPod" ]
then
/vfdecrypt -i /private/var/x/022-3742-100.dmg -k 11070c11d93b9be5069b643204451ed95aad37df7b332d10e48fd3d23c62fca517055816 -o /private/var/decrypted.dmg
else
/vfdecrypt -i /private/var/x/022-3743-100.dmg -k 11070c11d93b9be5069b643204451ed95aad37df7b332d10e48fd3d23c62fca517055816 -o /private/var/decrypted.dmg
fi

rm -rf /private/var/x
/dmg2img -v /private/var/decrypted.dmg /private/var/disk0s1.dd
rm /private/var/decrypted.dmg

umount -f /private/var
mount /private/var
mkdir /mnt
mount -o ro /
vncontrol attach /dev/vn0 /private/var/disk0s1.dd
mount_hfs /dev/vn0 /mnt
cp /System/Library/Caches/com.apple.kernelcaches/kernelcache.s5l8900xrb /mnt/System/Library/Caches/com.apple.kernelcaches/kernelcache.s5l8900xrb
cp /etc/fstab /mnt/etc/fstab
cp -u /bin/* /mnt/bin/
cp -u /sbin/* /mnt/sbin/
cp -u /usr/libexec/* /mnt/usr/libexec/
cp -u /usr/bin/* /mnt/usr/bin/
cp -u /usr/sbin/* /mnt/usr/sbin/
cp /etc/ssh* /mnt/etc/
cp /Services.plist /mnt/System/Library/Lockdown/
cp /usr/lib/libarmfp.dylib /mnt/usr/lib/libarmfp.dylib
cp /Library/LaunchDaemons/* /mnt/Library/LaunchDaemons/

cp -a /Installer.app /mnt/Applications/

chmod a+x /mnt/Applications/Installer.app/Installer
chmod +s /mnt/Applications/Installer.app/Installer

cp -a /com.devteam.rm.plist /mnt/System/Library/LaunchDaemons/
ln -s "/private/var/terminfo" /mnt/usr/share/terminfo

if [ "$PLATFORM" = "iPod" ]
then
else
/ipatcher -l /mnt/usr/libexec/lockdownd
fi

sync
umount /mnt
sync
fsck_hfs /dev/vn0
sync
vncontrol detach /dev/vn0
sync

vncontrol attach /dev/vn0 /private/var/disk0s1.dd
mount_hfs /dev/vn0 /mnt
sync
umount /mnt
sync
fsck_hfs /dev/vn0
sync
vncontrol detach /dev/vn0
sync

cp -a /usr/share/terminfo /private/var/

mkdir /private/var/db/timezone
mv /private/var/db/localtime /private/var/db/timezone/localtime
mv /private/var/root/Library/Keychains /private/var/Keychains
chown -R 64:64 /private/var/Keychains

mv /private/var/root/Library/Preferences/SystemConfiguration /private/var/preferences/SystemConfiguration
mv /private/var/root/Library/Preferences/csidata /private/var/preferences/csidata
mv /private/var/root/Media /private/var/mobile/Media
rm -rf /private/var/mobile/Library
mv /private/var/root/Library /private/var/mobile/Library
mkdir /private/var/root/Library
mv /private/var/mobile/Library/Lockdown /private/var/root/Library/Lockdown
chown -R mobile:mobile /private/var/mobile
chown -R mobile /private/tmp/MediaCache

mkdir /private/var/logs/Baseband
mkdir /private/var/logs/AppleSupport
chmod a+rwx /private/var/logs/Baseband /private/var/logs/AppleSupport

cp /update-prebinding-paths.txt /private/var/db/dyld/

sync
sync
sync
cp /private/var/disk0s1.dd /dev/rdisk0s1
reboot
